#!/usr/bin/perl -I/usr/sausalito/handlers/base/winshare -I/usr/sausalito/perl
# $Id: domain_admins.pl,v 1.1 2001/12/17 19:51:16 will Exp $
#
# Copyright(c) 2000, 2001 Sun Microsystems, Inc.
# Will DeHaan <null@sun.com>
#
# Keep /etc/group's winshare group in sync with the User.capabilities 
# modifyWinshare property roster
#
use Sauce::Service;
use Sauce::Util;
use CCE;

my $cce = new CCE;
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

# system group 'winshare' members hash
my @winshare = getgrnam('winshare');
my %members = map{$_, 1} split(/\s/, $winshare[3]);

my $dirty_groups = 0; # Set to 1 to rewrite /etc/groups

# Ensure admin and root are winshare members
if(!$members{'admin'} || !$members{'root'})
{
	$members{'admin'} = $members{'root'} = 1;
	$dirty_groups = 1;
}

if(($cce->event_is_destroy() && $members{$old->{name}}) ||
	(($obj->{capabilities} !~ /&(modifyWinshare|systemAdministrator)&/) &&
	 $members{$obj->{name}}))
{
	# delete $old->{name} from the winshare roster
	delete($members{$old->{name}});
	$dirty_groups = 1;
}
elsif (($obj->{capabilities} =~ /&(modifyWinshare|systemAdministrator)&/) &&
	!$members{$obj->{name}})
{
	# add $obj->{name} to the winshare roster
	$members{$obj->{name}} = 1;
	$dirty_groups = 1;
}

# edit groups
if($dirty_groups)
{
	# create the winshare group if necessary
	system('/usr/sbin/groupadd', 'winshare') unless ($winshare[0]);

	my $ret = Sauce::Util::editfile(
		'/etc/group', *edit_group, 'winshare', keys %members);
	chmod(0644, '/etc/group');

}

$cce->bye('SUCCESS');
exit 0;


# Subs

sub edit_group
{
	my ($fin, $fout, $group) = (shift, shift, shift);

	my $found = 0;
	while(<$fin>)
        {
                if (m/^$group:x:\d+:/) {
			my @bits = split(/:/, $_);
			$bits[3] = join(',',@_);
			$_ = join(':', @bits)."\n";
			$found = 1;
                }
                print $fout $_;
        }
	return $found;
}


