#!/usr/bin/perl -I. -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# modify global and guest-share for guest access.
#
use Sauce::Util;
use Sauce::Service;
use Sauce::Config;
use CCE;
use smb;

my $cce = new CCE(Namespace => 'FileShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

my (%settings,$err);

if (($old->{guestEnabled} ne $obj->{guestEnabled}) or
    ($old->{guestWorkGroup} ne $obj->{guestWorkGroup})) { 
    $err = Sauce::Util::editfile(smb::smb_getconf, *smb::edit_guest,
				$old->{guestWorkGroup}, $obj->{guestWorkGroup},
				$obj->{guestEnabled});
    if ($err) {
	$cce->bye('FAIL', '[[base-winshare.cantToggleSetting]]');
	exit 1;
    }
}

if ($old->{guestUser} ne $obj->{guestUser}) {
    $settings{'guest account'} = $obj->{guestUser};
    $err = Sauce::Util::editfile(smb::smb_getconf, *smb::edit_global,
				    %settings);
    if ($err) {
	$cce->bye('FAIL', '[[base-winshare.cantConfigFile]]');
	exit 1;
    }
}

# now, restart samba
my ($oid) = $cce->find('System');
my $ok;
($ok, $obj) = $cce->get($oid, 'WinShare');
Sauce::Service::service_toggle_init('smb', $obj->{enabled});
$cce->bye('SUCCESS');
exit 0;
