#!/usr/bin/perl -I/usr/sausalito/handlers/base/winshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# modify system properties for windows file sharing. notice how
# remarkably similar this file is to the winnetwork system.pl.
#
use Sauce::Service;
use Sauce::Util;
use CCE;
use smb;

my $cce = new CCE;
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

# we only need to modify the group if the name changes 
my $err = Sauce::Util::editfile(smb::smb_getconf, *smb::edit_group, 
				$old->{name}, $obj->{name});
if ($err) {
	$cce->bye('FAIL', '[[base-winshare.cantModifyGroup]]');
	exit 1;
}

my ($oid) = $cce->find('System');
my $ok;
($ok, $obj) = $cce->get($oid, 'WinShare'); 
Sauce::Service::service_toggle_init('smb', $obj->{enabled});
$cce->bye('SUCCESS');
exit 0;
