#!/usr/bin/perl -I/usr/sausalito/handlers/base/winshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# modify smb password file.
#
use Sauce::Util;
use CCE;
use smb;

my $cce = new CCE;
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();
my $uid = getpwnam($obj->{name});

# edit the smb password file. we pass in the old user
# so that we can match existing entries.  
my $err = Sauce::Util::editfile(smb::smb_getpasswd, *smb::edit_smbpass, 
				$obj->{name}, $uid, $obj->{password}, 
				$obj->{fullName}, $obj->{shell}, 
				$old->{name});

if($err == -1) {
    $err = system('/usr/bin/smbpasswd', $obj->{name}, $obj->{password});
    $err = 0 if ($err > 2); # friendly smbpasswd errors tolerated
}

if ($err) {
    $cce->bye('FAIL', '[[base-winshare.cantModifyPassword]]');
    exit 1;
}

# check if this is the admin user..., if so, update root's password
if ($obj->{systemAdministrator}) {
	my $err = Sauce::Util::editfile(smb::smb_getpasswd, *smb::edit_smbpass, 
				'root', 0, $obj->{password}, 
				$obj->{fullName}, $obj->{shell}, 
				'root');
	system('/usr/bin/smbpasswd', 'root', $obj->{password}) if ($err == -1);
}

# restart smb if it's running.
Sauce::Service::service_run_init('smb', 'restart') 
	if Sauce::Service::service_get_init('smb');

$cce->bye('SUCCESS');
exit 0;
