#!/usr/bin/perl -I/usr/sausalito/handlers/base/winshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# modify system properties for windows file sharing. notice how
# remarkably similar this file is to the winnetwork system.pl.
#
use Sauce::Service;
use Sauce::Util;
use CCE;
use smb;

sub edit_rc
{
    my ($input, $output, $enabled) = @_;
    
    while (<$input>) {
	# skip comments
	if (/^\s*\#/o) {
	    print $output $_;
	    next;
	}

	if (/^[\s]*SMB_ENABLED=/) {
	    print $output "SMB_ENABLED=$enabled\n";
	    next;
	}

	print $output $_;
    }
    return 0;
}

my $cce = new CCE(Namespace => 'WinShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

my %settings;

# maximum number of users. always set this.
$settings{'max connections'} = $obj->{maxConnections};

if (%settings) {
    my $err = Sauce::Util::editfile(smb::smb_getconf, *smb::edit_global, 
				     %settings);
    if ($err) {
	$cce->bye('FAIL', '[[base-winshare.cantToggleSetting]]');
	exit 1;
    }
}

# toggle the init state.
Sauce::Service::service_toggle_init('smb', $obj->{enabled}); 
$cce->bye('SUCCESS');
exit 0;
